// Generated by CoffeeScript 1.6.3
var exec, os, spawn, util;

exec = require('child_process').exec;

spawn = require('child_process').spawn;

os = require('os');

util = require('util');

exports.execUntilEmpty = function(commands, callback) {
  var command;
  command = commands.shift();
  return exec(command, function(err, stdout, stderr) {
    if (err) {
      console.log(stderr);
      return callback(err.code);
    } else if (commands.length > 0) {
      return exports.execUntilEmpty(commands, callback);
    } else {
      return callback(0);
    }
  });
};

exports.spawnUntilEmpty = function(commands, callback) {
  var command, commandDescriptor, name;
  commandDescriptor = commands.shift();
  if (exports.isRunningOnWindows()) {
    name = commandDescriptor.name;
    commandDescriptor.name = "cmd";
    commandDescriptor.args.unshift(name);
    commandDescriptor.args.unshift('/C');
  }
  command = spawn(commandDescriptor.name, commandDescriptor.args, commandDescriptor.opts);
  if (os.platform().match(/^win/)) {
    name = commandDescriptor.name;
    commandDescriptor.name = "cmd";
    commandDescriptor.args.unshift(name);
    commandDescriptor.args.unshift('/C');
  }
  command.stdout.on('data', function(data) {
    return util.print("" + data);
  });
  command.stderr.on('data', function(data) {
    return util.print("" + data);
  });
  return command.on('close', function(code, signal) {
    if (commands.length > 0 && code === 0) {
      return exports.spawnUntilEmpty(commands, callback);
    } else {
      return callback(code);
    }
  });
};

exports.isRunningOnWindows = function() {
  return os.platform().match(/^win/);
};
